/* This file is part of syscalltrack, a GNU/Linux kernel module and */
/* user space utilities for logging or modifying any system call    */
/* invocation.                                                      */
/*                                                                  */
/* Copyright (C) 2000-2002 Muli Ben-Yehuda, mulix@actcom.co.il	    */
/* License: GNU General Public License                              */

/*
 * $Id: conditional_intf.h,v 1.7 2002/06/15 15:16:13 mulix Exp $
 */ 

#ifndef CONDITIONAL_INTF_H_
#define CONDITIONAL_INTF_H_

#include <string>
#include <iostream>

#include "param_types.h"
#include "../sct_rules/rule_engine_public.h"

using namespace std; 

class conditional_intf
{
 public:
    conditional_intf() {};
    virtual ~conditional_intf() {};

    virtual bool validate(const string& syscall_name) = 0;

    virtual sct_filter_node_t* sct_get_filter_node(void) const = 0;

    virtual ostream& print(ostream& os) = 0; 

    virtual bool finalize(const string& sys_name) = 0;

    virtual int get_line_num() = 0;

    virtual int get_data_line_num() = 0;

 protected:
    virtual sct_data_type_t query_required_data_type(const string& sys_name) = 0;
};

#endif /* CONDITIONAL_INTF_H_ */
