/* This file is part of syscalltrack, a GNU/Linux kernel module and */
/* user space utilities for logging or modifying any system call    */
/* invocation.                                                      */
/*                                                                  */
/* Copyright (C) 2000-2002 Muli Ben-Yehuda, mulix@actcom.co.il	    */
/* License: GNU General Public License                              */

/*
 *$Id: process_conditional.h,v 1.11 2002/06/15 15:16:13 mulix Exp $
 */

/* This is the a condition which is based upon the process which is 
 * executing the system call
 * @author: mulix@actcom.co.il
 */

#ifndef _PROCESS_CONDITIONAL_H_
#define _PROCESS_CONDITIONAL_H_

#include <iostream>
#include <string>

#include "conditional.h"
#include "param_types.h"

class process_conditional: public conditional
{
 public:
    process_conditional();
    ~process_conditional();
    process_conditional(const process_conditional& rhs); 

    bool validate(const string& sysname);

    void set_process_field(const string& str);
    process_field_t get_process_field() const;

    sct_filter_node_t* sct_get_filter_node(void) const;

    ostream& print(ostream& os);

    bool finalize(const string& sys_name);

 protected:
    sct_data_type_t query_required_data_type(const string& sys_name);
    
 private:
    process_field_t _proc_field;
};

#endif //_PARAM_CONDITIONAL_H_
