/* This file is part of syscalltrack, a GNU/Linux kernel module and */
/* user space utilities for logging or modifying any system call    */
/* invocation.                                                      */
/*                                                                  */
/* Copyright (C) 2000-2002 Muli Ben-Yehuda, mulix@actcom.co.il	    */
/* License: GNU General Public License                              */

/*
 *$Id: token.cpp,v 1.7 2002/06/15 15:16:13 mulix Exp $
 */
#include <iostream>
#include <assert.h>

#include "token.h"
#include "tokens_to_types.h"


ostream& operator<<(ostream& os, const parser_token_t& t)
{
    return os<<tokens::get_parser_token_str(t);
}

ostream& operator<<(ostream& os, const token& t)
{
    os<<"token type: '"<<t._type<<"'"<<endl;
    if (!t._value.empty()){
	os<<"token value: '"<<t._value<<"'"<<endl;
    }
    return os;
}
