/* This file is part of syscalltrack, a GNU/Linux kernel module and */
/* user space utilities for logging or modifying any system call    */
/* invocation.                                                      */
/*                                                                  */
/* Copyright (C) 2000-2002 Muli Ben-Yehuda, mulix@actcom.co.il	    */
/* License: GNU General Public License                              */

/*
 *$Id: validity_checks.cpp,v 1.12 2002/06/15 15:16:13 mulix Exp $
 */

using namespace std;

#include <string>
#include <limits.h>

#include <errno.h>

#include "syscalls.h"

extern syscalls syscalls_info;

bool is_int(const string& str)
{
    /* from the strtol man page */
    int res; 
    char* endpt = NULL;
    const char* cstr = str.c_str();
    res = strtol(cstr, &endpt, 0);
    if ((res == LONG_MIN || res == LONG_MAX) && errno == ERANGE)
	return false;

    if (*endpt)
	return false;

    return true;
}

bool is_float(const string& str)
{
    //TODO: implement me
    return true; 
}

bool is_long(const string& str)
{
    //for the time being
    return is_int(str);
}

bool is_syscall_identifier(const string& str)
{
    return syscalls::has_syscall(str);
}

bool is_value(const string& str)
{
    //is_value needs to know about different value types,
    //how do we pass this information to it?
    return true;
}

