/* This file is part of syscalltrack, a GNU/Linux kernel module and */
/* user space utilities for logging or modifying any system call    */
/* invocation.                                                      */
/*                                                                  */
/* Copyright (C) 2000-2002 Muli Ben-Yehuda, mulix@actcom.co.il	    */
/* License: GNU Lesser General Public License                       */

/*
 * $Id: dev_file_private.h,v 1.3 2002/06/15 15:16:13 mulix Exp $
 */ 

#ifndef DEV_FILE_PRIVATE_H_
#define DEV_FILE_PRIVATE_H_

#include "sct_ctrl_lib.h"
#include "sct_rules_module/module_interface.h"

int 
dev_file_update_kernel(sct_ctrl_t ctrl, unsigned int cmd, 
		       int rule_id, sct_rule_when_t when, int syscall_id, 
		       unsigned char* buf, unsigned int length, 
		       int enable_rule);

void
build_request(dev_req_t* req, unsigned int cmd,
	      int rule_id, sct_rule_when_t when, int syscall_id, 
	      unsigned char* buf, unsigned int length, int enable_rule); 


/* submit this request to the device file, and return the response in 'resp' */ 
/* return 1 on success, 0 on error */ 
int
dev_file_do_request(sct_ctrl_t ctrl, dev_req_t* req, dev_req_t* resp); 

const char* 
resp_result_to_string(int res); 

void 
destroy_request(dev_req_t* req); 

#endif /* DEV_FILE_PRIVATE_H_ */ 
