/*
 * TEST_TITLE: write (when = before, test buffer)
 * TEST_SYSCALL: write
 * TEST_WHEN: before
 * TEST_RULE_1: PARAMS[2] =~ "/tmp/sct"
 * TEST_RULE_2: COMM != "klogd"
 * TEST_EXPECT: 1
 * TEST_EXPECT_PARAMS: /tmp/sct
 * TEST_TIMEOUT: 10
 * TEST_END
 *
 * TEST_TITLE: write (when = after, test buffer)
 * TEST_SYSCALL: write
 * TEST_WHEN: after
 * TEST_RULE_1: PARAMS[2] =~ "/tmp/sct"
 * TEST_RULE_2: COMM != "klogd"
 * TEST_EXPECT: 1
 * TEST_EXPECT_PARAMS: /tmp/sct
 * TEST_TIMEOUT: 10
 * TEST_END
 * 
 * TEST_TITLE: read (when = before, test buffer)
 * TEST_SYSCALL: read
 * TEST_WHEN: before
 * # we have to avoid the read() call every program makes for loading libc
 * # since we can't rely on the fd, we rely on the buffer size. yuck indeed. 
 * TEST_RULE_1: PARAMS[2] ~= "AAA" && PARAMS[3] == 32
 * TEST_EXPECT: 1
 * TEST_EXPECT_PARAMS: AAA
 * TEST_TIMEOUT: 10
 * TEST_END
 *
 * TEST_TITLE: read (when = after, test buffer)
 * TEST_SYSCALL: read
 * TEST_WHEN: after
 * # we have to avoid the read() call every program makes for loading libc
 * # since we can't rely on the fd, we rely on the buffer size. yuck indeed. 
 * TEST_RULE_1: PARAMS[2] ~= "/tmp/sct" && PARAMS[3] == 32
 * TEST_EXPECT: 1
 * TEST_EXPECT_PARAMS: /tmp/sct
 * TEST_TIMEOUT: 10
 * TEST_END
 *
 */
#include <unistd.h>
#include <stdlib.h> /* mkstemp */ 

int main()
{	
	char buf[32]; 
	int rc; 
	int f; 
	int sz; 
	
	snprintf(buf, sizeof(buf), "/tmp/sctXXXXXX"); 
	f = mkstemp(buf); 
	if (f == -1) {
		perror("mkstemp"); 
		return -1; 
	}

	sz = sizeof(buf); 
	if ((rc = write(f, buf, sz)) != sz) {
		perror("write"); 
		return -1; 
	}
	/* seek to the beginning of the file, so we can read */ 
	/* what we wrote */ 
	lseek(f, 0, SEEK_SET); 

	memset(buf, 'A', sz); 

	if ((rc = read(f, buf, sz)) != sz) {
		perror("read"); 
		return -1; 
	}

    	return 0; 
}
