#!/usr/bin/tclsh

# This file is part of syscalltrack, a GNU/Linux kernel module and
# user space utilities for logging or modifying any system call    
# invocation.                                                      
#                                                                  
# Copyright (C) 2000-2002 Amir Shalem, <amir@boom.org.il> 
# License: GNU General Public License                              

#
# $Id: sct_config.tcl,v 1.2 2002/06/15 15:16:14 mulix Exp $
# 

# pretty ugly script.

set ops {== < > <= >= != + - << >> & |}

# the second part is if to use ( or not.
set connecting_ops {{&& 0} {|| 0} {&& 1} {|| 1}}

set my_tmpl {

rule
{
        syscall_name=unlink
        rule_name=second_unlink_rule
	when:after
	filter_expression {%s}
        action:LOG
}

}

proc make_sct_config_check_it {ex} {
    global my_tmpl
    puts $ex
    set tmpl [format $my_tmpl $ex]
    catch { exec ./sct_config check - << $tmpl } output

    if {[lsearch [split $output " "] {quitting.}] >= 0} {
	puts $output
	puts "---------------------------------------------------"
	puts "on expression: $ex"
	exit
    }
}

proc randnum {} {
    return [expr int(rand() * (9) + 1)]
}

proc check_filter_done {cg count ops} {
    set ex ""
    set close_now 0
    foreach {x} $cg op $ops {
	set doit [lindex $op 1]
	set op   [lindex $op 0]
	if {$doit == ""} { set doit 0 }
	
	set s1 ""
	set s2 ""
	if {$doit && !$close_now} {
	    set close_now 1
	    set s1 "("
	} elseif {!$doit && $close_now} {
	    set close_now 0
	    set s2 ")"
	}
	lappend ex "${s1}[randnum] $x [randnum]${s2} $op"
    }
    if {$close_now} {
	lappend ex ")"
    }
    make_sct_config_check_it [string trim [join $ex]]
}

proc check_filter {count cg} {
    global connecting_ops
    do_rec [expr $count - 1] "check_filter_done {$cg}" $connecting_ops
}

proc do_rec {end func vg {cg {}} {count 0}} {
    if {$count == $end} {
	eval $func \"$count\" \"$cg\"
    }
    if {$count == $end} {
	return
    }
    incr count 
    foreach i $vg {
        do_rec $end $func $vg [concat $cg [list $i]] $count
    }    
}

do_rec 1 check_filter $ops
do_rec 2 check_filter $ops
do_rec 3 check_filter $ops
do_rec 4 check_filter $ops
