/*
 * $Id: sct_rules_tests.c,v 1.10 2002/06/13 18:10:11 mulix Exp $
 */
#include <stdio.h>
#include <sys/time.h>
#include <unistd.h>

#include "sct_rules/rule_engine_public.h"
#include "sct_rules/filter_vars_public.h"

#include "tester.h"

/* NOTE: this file is a complete mess, a simple copy and paste job 
   from sct_rules/main.c. it needs to be rearranged, extended and 
   cleaned up. it has memory leaks. it sucks. but it's a start */

/* filter evaluation testing */
int
test_filter_eval_bit(void)
{
    sct_filter_node_t* result = sct_make_bool_val(TF_FALSE);
    sct_exp_error_t rc;
    
    {
	sct_filter_node_t* f0 = sct_make_long_val(120L);
	sct_filter_node_t* f1 = sct_make_long_val(30L);
	sct_filter_node_t* f2 = sct_make_bit_and(f0, f1);
	
	printf("\n");
	printf("Evaluating filter:\n");
	sct_print_filter_node(f2);
	rc = sct_eval_filter_node(f2, result);
	printf("sct_eval_filter_node returned '%d'\n", rc);
	if (rc != ERR_NONE) {
	    return 0;
	}
	printf("result:\n");
	sct_print_filter_node(result);
	printf("\n");
	sct_free_filter_node(f2);
    }
    {
	sct_filter_node_t* f0 = sct_make_long_val(120L);
	sct_filter_node_t* f1 = sct_make_long_val(30L);
	sct_filter_node_t* f2 = sct_make_bit_or(f0, f1);
	
	printf("\n");
	printf("Evaluating filter:\n");
	sct_print_filter_node(f2);
	rc = sct_eval_filter_node(f2, result);
	printf("sct_eval_filter_node returned '%d'\n", rc);
	if (rc != ERR_NONE) {
	    return 0;
	}
	printf("result:\n");
	sct_print_filter_node(result);
	printf("\n");
	sct_free_filter_node(f2);
    }
    {
	sct_filter_node_t* f0 = sct_make_long_val(120L);
	sct_filter_node_t* f1 = sct_make_long_val(30L);
	sct_filter_node_t* f2 = sct_make_bit_xor(f0, f1);
	
	printf("\n");
	printf("Evaluating filter:\n");
	sct_print_filter_node(f2);
	rc = sct_eval_filter_node(f2, result);
	printf("sct_eval_filter_node returned '%d'\n", rc);
	if (rc != ERR_NONE) {
	    return 0;
	}
	printf("result:\n");
	sct_print_filter_node(result);
	printf("\n");
	sct_free_filter_node(f2);
    }
    
    sct_free_filter_node(result);
    return 1;
}

sct_filter_node_t* get_a_filter_expression(void)
{
    sct_filter_node_t* f0 = sct_make_string_val("hello world");
    sct_filter_node_t* f1 = sct_make_string_val("lo w");
    sct_filter_node_t* f2 = sct_make_pattern_match(f0, f1);
    sct_filter_node_t* f3 = sct_make_int_val(15);
    sct_filter_node_t* f4 = sct_make_logical_and(f2, f3);
    return f4;
}

int 
test_eval_complex_filter(void)
{
    struct timeval t1, t2;
    sct_filter_node_t* result = sct_make_bool_val(TF_FALSE);
    sct_exp_error_t rc;
    sct_filter_node_t* f4 = get_a_filter_expression();
    
    printf("Printing filter node.\n");
    sct_print_filter_node(f4);
    
    gettimeofday(&t1, NULL);
    rc = sct_eval_filter_node(f4, result);
    gettimeofday(&t2, NULL);
    
    printf("   time before eval: %ld, %ld\n", t1.tv_sec, t1.tv_usec);
    printf("   time after  eval: %ld, %ld\n", t2.tv_sec, t2.tv_usec);
    printf("Expression result (rc = %d):\n", rc);
    sct_print_filter_node(result);
    sct_free_filter_node(f4);
    sct_free_filter_node(result);
    return 1;
    
}

/* filter serialization/deserializatin testing. */
int
test_filter_serialize_deserialize(void)
{
    unsigned char buf[1000];
    sct_filter_node_t* f4 = get_a_filter_expression();
    int len = sct_serialize_filter_node(f4, buf, 1000);
    int rc = 0; /* assume failure */
    printf("serialized 'f4' into '%d' bytes\n", len);
    
    if (len > 0) {
	sct_filter_node_t* f_deser =
	    sct_deserialize_filter_node(buf, len);
	if (f_deser) {
	    printf("'f4' deserialized:\n");
	    sct_print_filter_node(f_deser);
	    sct_free_filter_node(f_deser);
	    rc = 1;
	}
	else {
	    printf("Deserialization of 'f4' failed.\n");
	}
    }

    sct_free_filter_node(f4); 
    return rc;
}


	/* tracking rules serialization/de-serialization testing. */
int
test_rules_serialize_deserialize(void)
{
    unsigned char buf[1000];
    sct_action_t* a1 = sct_make_action_log(4, NULL);
    sct_filter_node_t* f4 = get_a_filter_expression();
    int len = sct_serialize_tracking_rule(1, RW_BEFORE, 10, a1, f4, buf, 1000);
    int rc = 0;
    printf("serialized rule 1 into '%d' bytes\n", len);
    
    if (len > 0) {
	sct_action_t* a_deser;
	sct_filter_node_t* f_deser;
	int rule_id;
	sct_rule_when_t when;
	int syscall_id;
	int res = sct_deserialize_tracking_rule(buf,
						len,
						&rule_id,
						&when,
						&syscall_id,
						&a_deser,
						&f_deser);
	if (res > 0) {
	    printf("rule 1 deserialized:\n");
	    printf(" rule_id - %d\n", rule_id);
	    printf(" when - %d (%s)\n",
		   when, (when == RW_BEFORE ? "before" : "after"));
	    printf(" syscall_id - %d\n", syscall_id);
	    sct_print_action_node(a_deser);
	    sct_print_filter_node(f_deser);
	    sct_free_filter_node(f_deser);
	    sct_free_action(a_deser); 
	    rc = 1;
	}
	else {
	    printf("Deserialization of rule 1 failed.\n");
	}
    }
    sct_free_action(a1); 
    sct_free_filter_node(f4); 
    return rc;
}

/* tracking rules add/delete testing. */
int 
test_tracking_rule_add_delete(void)
{
    sct_rule_list_t* rules;
    sct_action_t* a1 = sct_make_action_log(4, NULL);
    sct_action_t* a2 = sct_make_action_disable_rule(6);
    sct_filter_node_t* f4 = get_a_filter_expression();
    sct_filter_node_t* f5 = get_a_filter_expression();
    int rc = 0;
    
    printf("creating tracking rules list\n");
    rules = sct_create_tracking_rule_list();
    printf("adding tracking rules\n");
    rc = sct_add_tracking_rule(rules, 6, f4, a1);
    rc = sct_add_tracking_rule(rules, 3, f5, a2);
    
    sct_print_tracking_rules(rules);
    
    printf("deleting all tracking rules\n");
    sct_del_all_tracking_rules_in_list(rules);
    sct_print_tracking_rules(rules);
    sct_delete_tracking_rule_list(rules);

    return 1;
}

/* tracking rules add/delete testing. */
int 
test_tracking_rule_add_delete_empty_list(void)
{
    sct_rule_list_t* rules = NULL;
    sct_action_t* a1 = sct_make_action_log(4, NULL);
    sct_action_t* a2 = sct_make_action_disable_rule(6);
    sct_filter_node_t* f4 = get_a_filter_expression();
    sct_filter_node_t* f5 = get_a_filter_expression();
    int rc = 0;
    
    printf("adding tracking rules to empty list\n");
    rc = sct_add_tracking_rule(rules, 6, f4, a1);
    rc = sct_add_tracking_rule(rules, 3, f5, a2);
    
    printf("printing empty list\n");
    sct_print_tracking_rules(rules);
    
    printf("deleting all tracking rules\n");
    sct_del_all_tracking_rules_in_list(rules);
    sct_print_tracking_rules(rules);
    sct_delete_tracking_rule_list(rules);

    sct_free_action(a1); 
    sct_free_action(a2); 
    sct_free_filter_node(f4); 
    sct_free_filter_node(f5); 
    return 1;
}


/* kernel variables assignment testing. */
int
test_kernel_variables(void)
{
    sct_exp_error_t res;
    sct_filter_node_t* v_sys_id = sct_make_int_val(10);
    sct_filter_node_t* v_param_0 = sct_make_string_val("/etc/passwd");
    sct_filter_node_t* f0 = sct_make_var_val(VT_SYSCALL_ID, DT_INT);
    sct_filter_node_t* f1 = sct_make_var_indexed_val(VT_PARAM, 0, DT_STRING);
    sct_filter_node_t* result = sct_make_bool_val(TF_FALSE);
    
    reset_all_vars();
    set_var(VT_SYSCALL_ID, v_sys_id);
    set_var_indexed(VT_PARAM, 0, v_param_0);
    
    res = sct_eval_filter_node(f0, result);
    printf("syscall_id (%d):\n", res);
    sct_print_filter_node(result);
    
    res = sct_eval_filter_node(f1, result);
    printf("param 0 (%d):\n", res);
    sct_print_filter_node(result);

    reset_all_vars(); 
    sct_free_filter_node(f0); 
    sct_free_filter_node(f1); 
    sct_free_filter_node(result); 
    return 1;
}

/* check short circuiting */
int 
test_short_circuiting(void)
{
    int rc;
    sct_filter_node_t* f0 = sct_make_int_val(1);
    sct_filter_node_t* f1 = sct_make_int_val(0);
    sct_filter_node_t* f2 = sct_make_int_val(1);
    sct_filter_node_t* f3 = sct_make_int_val(0);
    sct_filter_node_t* f_and = sct_make_logical_and(f0, f1);
    sct_filter_node_t* f_or = sct_make_logical_or(f2, f3);
    sct_filter_node_t* result = sct_make_bool_val(TF_FALSE);
    
    printf("-------------------\n");
    rc = sct_eval_filter_node(f_and, result);
    
    printf("short circuiting support test: and - '%d'\n",rc);
    sct_print_filter_node(result);
 	
    rc = sct_eval_filter_node(f_or, result);
    printf("short circuiting support test: or - '%d'\n",rc);
    sct_print_filter_node(result);
    sct_free_filter_node(result);
    sct_free_filter_node(f_and);
    sct_free_filter_node(f_or); 
    
    return 1;
}

int 
test_indexed_field_variables(void)
{
    sct_filter_node_t* result = sct_make_bool_val(TF_FALSE);
    sct_exp_error_t rc;
    
    printf("\n\n\n-------------------\n");
    printf("Testing variables\n");
    {
	sct_filter_node_t* v_param_0 = sct_make_filter_vector(2);
	sct_filter_node_t* f0 = sct_make_string_val("/bli/bla");
	sct_filter_node_t* f1 = sct_make_int_val(7);
	sct_filter_node_t* filter_0_0 =
	    sct_make_var_indexed_field_val(VT_PARAM, 0, 0, DT_STRING, -1);
	sct_filter_node_t* filter_0_1 =
	    sct_make_var_indexed_field_val(VT_PARAM, 0, 1, DT_STRING, -1);
	sct_insert_filter_node(v_param_0, 0, f0);
	sct_insert_filter_node(v_param_0, 1, f1);
	
	reset_all_vars();
	set_var_indexed(VT_PARAM, 0, v_param_0);
	
	rc = sct_eval_filter_node(filter_0_0, result);
	printf("param 0.0 (%d):\n", rc);
	sct_print_filter_node(result);

	rc = sct_eval_filter_node(filter_0_1, result);
	printf("param 0.1 (%d):\n", rc);
	sct_print_filter_node(result);
	
	sct_free_filter_node(filter_0_0);
	sct_free_filter_node(filter_0_1);
    }

    sct_free_filter_node(result);

    return 1;
}

/* test filter node vectors. */
int
test_filter_node_vectors(void)
{
    printf("\n\n\n");
    printf("Testing filter node vectors\n\n");
    
    {
	int rc;
	sct_filter_node_t* f0 = sct_make_ulong_val(120L);
	sct_filter_node_t* f1 = sct_make_ulong_val(30L);
	sct_filter_node_t* f2 = sct_make_math_plus(f0, f1);
	sct_filter_node_t* f3 = sct_make_bool_val(0);
	sct_filter_node_t* f4 = sct_make_int_val(10);
	sct_filter_node_t* f5 = sct_make_int_val(20);
	sct_filter_node_t* f6 = sct_make_equal(f4, f5);
	sct_filter_node_t* vec = sct_make_filter_vector(5);
	
	rc = sct_insert_filter_node(vec, 0, f2);
	rc = sct_insert_filter_node(vec, 1, f3);
	rc = sct_insert_filter_node(vec, 2, f6);
	
	sct_print_filter_node(vec);
	
	sct_free_filter_node(vec);
    }
    printf("\n\n\n");

    return 1;
}

